MODULE H2P;
(*   *)
(*            62,            .
   "0".."9"    0  9
   "A".."Z"    10  35
   "a".."z"    36  61 *)
(*  1  0 *)
(*  CyberPunk, 2013 *)

(*--------------------------------------------------------------------------------------------------------*)
	IMPORT Console, CPmain, StdIn;

(*--------------------------------------------------------------------------------------------------------*)
	TYPE
		TNumber = RECORD
			digits : ARRAY 32 OF INTEGER;
			index : INTEGER
		END;

		TPassword = RECORD
			psw : ARRAY 173 OF CHAR;
			len : INTEGER
		END;

(*--------------------------------------------------------------------------------------------------------*)
	PROCEDURE ^ Run;
	PROCEDURE ^ CheckStr (IN str : ARRAY OF CHAR; OUT len : INTEGER; OUT res : BOOLEAN);
	PROCEDURE ^ ConvertString (IN str : ARRAY OF CHAR; len : INTEGER; OUT num : TNumber);
	PROCEDURE ^ QuotRem (VAR num : TNumber; OUT rem : LONGINT);

(*--------------------------------------------------------------------------------------------------------*)
	PROCEDURE Run;
		VAR
			str : ARRAY 256 OF CHAR;
			stLen : INTEGER;
			stRes : BOOLEAN;
			number : TNumber;
			password : TPassword;
			rem : LONGINT;
			i : INTEGER;
			ch : CHAR;
	BEGIN
		Console.WriteString('The program converts the entered hexadecimal number to an alphanumeric password. The maximum length of the number is 255 characters.');
		Console.WriteLn;
		Console.WriteString(' CyberPunk, 2013');
		Console.WriteLn;
		Console.WriteString('Enter a hexadecimal number > ');
		StdIn.ReadLn(str);
		CheckStr(str, stLen, stRes);
		IF stRes THEN
			IF stLen > 0 THEN
				ConvertString(str, stLen, number);
				password.len := 0;
				REPEAT
					QuotRem(number, rem);
					CASE SHORT(rem) OF
						0 .. 9 : password.psw[password.len] := CHR(rem + ORD('0'))
						| 10 .. 35 : password.psw[password.len] := CHR(rem - 10 + ORD('A'))
						| 36 .. 61 : password.psw[password.len] := CHR(rem - 36 + ORD('a'))
					END;
					INC(password.len)
				UNTIL number.digits[0] = 0;
				FOR i := 0 TO password.len DIV 2 - 1 DO
					ch := password.psw[i];
					password.psw[i] := password.psw[password.len - 1 - i];
					password.psw[password.len - 1 - i] := ch
				END;
				password.psw[password.len] := 0X;
				Console.WriteString('Password is ');
				Console.WriteString(password.psw)
			ELSE
				Console.WriteString('Error: zero-length string!')
			END
		ELSE
			Console.WriteString('Error: unknown character at position');
			Console.WriteInt(stLen, 0)
		END
	END Run;

(*--------------------------------------------------------------------------------------------------------*)
	PROCEDURE CheckStr (IN str : ARRAY OF CHAR; OUT len : INTEGER; OUT res : BOOLEAN);
		VAR
			i : INTEGER;
	BEGIN
		len := LEN(str);
		i := 0;
		WHILE (i < len) & ((str[i] >= '0') & (str[i] <= '9') OR (str[i] >= 'A') & (str[i] <= 'F') OR (str[i] >= 'a') & (str[i] <= 'f')) DO
			INC(i)
		END;
		res := (i < len) & (str[i] = 0X);
		len := i
	END CheckStr;

(*--------------------------------------------------------------------------------------------------------*)
	PROCEDURE ConvertString (IN str : ARRAY OF CHAR; len : INTEGER; OUT num : TNumber);
		VAR
			exp : INTEGER;
			val : BYTE;
			i : INTEGER;
	BEGIN
		exp := len;
		num.index := 0;
		num.digits[0] := 0;
		FOR i := 0 TO len - 1 DO
			DEC(exp);
			IF (exp MOD 8 = 7) & ((num.index # 0) OR (num.digits[num.index] # 0)) THEN
				INC(num.index);
				num.digits[num.index] := 0
			END;
			CASE str[i] OF
				'0'..'9' : val := SHORT(SHORT(ORD(str[i]) - ORD('0')))
				| 'A'..'F' : val := SHORT(SHORT(ORD(str[i]) - ORD('A') + 10))
				| 'a'..'f' : val := SHORT(SHORT(ORD(str[i]) - ORD('a') + 10))
			END;
			INC(num.digits[num.index], LSH(val, exp MOD 8 * 4))
		END
	END ConvertString;

(*--------------------------------------------------------------------------------------------------------*)
	PROCEDURE QuotRem (VAR num : TNumber; OUT rem : LONGINT);
		VAR
			last, i : INTEGER;
	BEGIN
		last := num.index;
		i := 0;
		num.index := 0;
		rem := 0;
		LOOP
			INC(rem, num.digits[i] MOD 100000000L);
			num.digits[num.index] := SHORT(rem DIV 62);
			rem := rem MOD 62;
			IF i = last THEN EXIT
			ELSE
				IF (num.index # 0) OR (num.digits[num.index] # 0) THEN INC(num.index) END;
				INC(i);
				rem := LSH(rem, 32)
			END
		END
	END QuotRem;

(*--------------------------------------------------------------------------------------------------------*)
BEGIN
	Run
END H2P.